﻿#version 330 core

// Interpolated values from the vertex shaders
in vec2 UV;
in vec4 particlecolor;
in vec3 vertexPosition_worldspace;	//vertex pos for fog

// Ouput data
out vec4 color;

uniform sampler2D myTextureSampler;
uniform vec3 viewPos;	//cam pos for fog

vec4 applyFog(vec4 col)
{
	vec3 fogColor = vec3(0.2156863, 0.1735566, 0.172549);
	fogColor = vec3(0);
	float FogDensity = 0.1;

	//exponential fog
	float dist = length(viewPos - vertexPosition_worldspace);
	float fogFac = clamp(1.0 /exp(pow(dist * FogDensity, 2)), 0.0, 1.0);

	return vec4( mix(fogColor, col.rgb, fogFac), col.a);
}

void main(){
	// Output color = color of the texture at the specified UV
	vec4 finalCol = texture( myTextureSampler, UV ) * particlecolor;
	finalCol = applyFog(finalCol);

	color = finalCol;

}